int main()
{
    int n,q;
    scanf("%d%d",&n,&q);
    for(int i=0;i<n;i++)
    {
        unsigned a;
        scanf("%u",&a);
        vekt.push_back(a);
    }
    for(int i=0;i<q;i++)
    {
        int l,r;
        scanf("%d%d",&l,&r);
        r-=1;
        unsigned suma=~0;
        for(int i=l-1;i<=r;i++)
        {
            suma&=vekt[i];
        }
        printf("%u\n",suma);
    }
    return 0;
}